package ru.dbotthepony.kstarbound.io.json.util

import com.google.gson.TypeAdapter
import com.google.gson.stream.JsonReader
import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kstarbound.Starbound

class LazyTypeProvider<T : Any?>(private val bound: Class<T>, private val resolver: (Class<T>) -> TypeAdapter<T> = Starbound::getTypeAdapter) : TypeAdapter<T>() {
	private val resolved by lazy { resolver(bound) }

	override fun write(out: JsonWriter, value: T) {
		resolved.write(out, value)
	}

	override fun read(`in`: JsonReader): T {
		return resolved.read(`in`)
	}
}
